"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const byParents_1 = require("./byParents");
const arrange_1 = require("./arrange");
const utils_1 = require("../utils");
exports.default = (store) => {
    const createFamily = byParents_1.default(store);
    const arrangeFamily = arrange_1.default(store);
    const root = store.familiesArray.filter(utils_1.withType('root'));
    for (const rootFamily of root) {
        let stack = rootFamily.cUnitsWithChildren.reverse();
        while (stack.length) {
            const familyUnit = stack.pop();
            const family = createFamily(familyUnit.nodes.map(utils_1.prop('id')), 'child');
            const parentFamily = store.getFamily(familyUnit.familyId);
            family.pID = parentFamily.id;
            family.top = parentFamily.top + 2;
            family.left = parentFamily.left + familyUnit.shift;
            arrangeFamily(family);
            store.families.set(family.id, family);
            const nextUnits = family.cUnitsWithChildren;
            if (nextUnits.length)
                stack = [...stack, ...nextUnits.reverse()];
        }
    }
    return store;
};
//# sourceMappingURL=create.js.map