"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const store_1 = require("./store");
const placeholders_1 = require("./middle/placeholders");
const create_1 = require("./middle/create");
const create_2 = require("./parents/create");
const create_3 = require("./children/create");
const connectors_1 = require("./connectors");
const correctPositions_1 = require("./utils/correctPositions");
const getCanvasSize_1 = require("./utils/getCanvasSize");
const getExtendedNodes_1 = require("./utils/getExtendedNodes");
const utils_1 = require("./utils");
const pipeline = utils_1.pipe(placeholders_1.default, create_1.default, create_2.default, create_3.default, correctPositions_1.default);
exports.default = (nodes, rootId) => {
    const families = pipeline(new store_1.default(nodes, rootId)).familiesArray;
    return {
        families: families,
        canvas: getCanvasSize_1.default(families),
        nodes: getExtendedNodes_1.default(families),
        connectors: connectors_1.default(families),
    };
};
//# sourceMappingURL=index.js.map