"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const setUnitDefShifts_1 = require("../utils/setUnitDefShifts");
const utils_1 = require("../utils");
exports.default = (lFamily, rFamily) => {
    const lChildren = lFamily.cUnits
        .reduce((a, b) => a.concat(b.nodes), []);
    const rChildren = rFamily.cUnits
        .reduce((a, b) => a.concat(b.nodes), []);
    const ids = lChildren.filter(node => !!rChildren.find(utils_1.withId(node.id))).map(utils_1.prop('id'));
    const shifts = lFamily.cUnits.map(utils_1.prop('shift'));
    lFamily.cUnits = lFamily.cUnits.sort((a, b) => {
        const foundA = !!a.nodes.find(node => ids.indexOf(node.id) !== -1);
        const foundB = !!b.nodes.find(node => ids.indexOf(node.id) !== -1);
        if (foundA && !foundB)
            return 1;
        else if (!foundA && foundB)
            return -1;
        return 0;
    });
    lFamily.cUnits.forEach((unit, idx) => unit.shift = shifts[idx]);
    rFamily.cUnits = rFamily.cUnits.filter(unit => (!!unit.nodes.find(node => ids.indexOf(node.id) === -1)));
    setUnitDefShifts_1.default(rFamily);
};
//# sourceMappingURL=fixOverlaps.js.map