"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const byChildren_1 = require("./byChildren");
const arrange_1 = require("./arrange");
const utils_1 = require("../utils");
exports.default = (store) => {
    const createFamily = byChildren_1.default(store);
    const arrangeFamily = arrange_1.default(store);
    const root = store.familiesArray.filter(utils_1.withType('root'));
    for (const rootFamily of root) {
        if (!rootFamily.main)
            continue;
        let stack = rootFamily.pUnitsWithParents.reverse();
        while (stack.length) {
            const familyUnit = stack.pop();
            const family = createFamily(familyUnit.nodes.map(utils_1.prop('id')));
            const childFamily = store.getFamily(familyUnit.familyId);
            family.cID = childFamily.id;
            family.top = childFamily.top - 2;
            family.left = childFamily.left + familyUnit.shift;
            arrangeFamily(family);
            store.families.set(family.id, family);
            const nextUnits = family.pUnitsWithParents;
            if (nextUnits.length)
                stack = [...stack, ...nextUnits.reverse()];
        }
    }
    return store;
};
//# sourceMappingURL=create.js.map