"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("./index");
exports.default = (store) => {
    const families = store.familiesArray;
    const vShift = index_1.min(families.map(index_1.prop('top'))) * -1;
    if (vShift !== 0)
        families.forEach(family => family.top += vShift);
    const rootChild = families.find(f => f.main);
    const rootParent = families.find(f => f.cID === rootChild.id);
    if (rootParent) {
        const cUnit = rootChild.pUnits[0];
        const pUnit = rootParent.cUnits[0];
        const diff = (rootParent.left + pUnit.shift) - (rootChild.left + cUnit.shift);
        if (diff > 0)
            families
                .filter(index_1.withType('child', 'root'))
                .forEach(family => family.left += diff);
        else if (diff < 0)
            families
                .filter(index_1.withType('parent'))
                .forEach(family => family.left += diff * -1);
        const hShift = index_1.min(families.map(index_1.prop('left')));
        if (hShift > 0)
            families.forEach(family => family.left -= hShift);
    }
    return store;
};
//# sourceMappingURL=correctPositions.js.map