"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const hasHiddenRelatives_1 = require("./hasHiddenRelatives");
const index_1 = require("./index");
const PARENTS = ['root', 'parent'];
const CHILDREN = ['root', 'child'];
const extendNode = (family) => (unit) => (unit.nodes.map((node, idx) => (Object.assign({}, node, { top: family.top + (unit.isChild ? 2 : 0), left: family.left + unit.shift + (idx * 2), hasSubTree: hasHiddenRelatives_1.default(family, node) }))));
const getParentNodes = (family) => (~PARENTS.indexOf(family.type) ? family.pUnits : []).map(extendNode(family));
const getChildNodes = (family) => (~CHILDREN.indexOf(family.type) ? family.cUnits : []).map(extendNode(family));
const mapFamily = (family) => [...getParentNodes(family), ...getChildNodes(family)].reduce(index_1.flat);
exports.default = (families) => families.map(mapFamily).reduce(index_1.flat);
//# sourceMappingURL=getExtendedNodes.js.map