"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const prop = (name) => (item) => item[name];
exports.prop = prop;
const withId = (id) => (item) => item.id === id;
exports.withId = withId;
const withType = (...types) => (item) => types.includes(item.type);
exports.withType = withType;
const withSameIDs = (target) => (unit) => target.ids.join('') === unit.ids.join('');
exports.withSameIDs = withSameIDs;
const flat = (items, item) => items.concat(item);
exports.flat = flat;
const unique = (item, index, arr) => arr.indexOf(item) === index;
exports.unique = unique;
const inAscOrder = (v1, v2) => v1 - v2;
exports.inAscOrder = inAscOrder;
const pipe = (...fus) => (init) => fus.reduce((res, fn) => fn(res), init);
exports.pipe = pipe;
const relToNode = (store) => (rel) => store.getNode(rel.id);
exports.relToNode = relToNode;
const min = (arr) => Math.min.apply(null, arr);
exports.min = min;
const max = (arr) => Math.max.apply(null, arr);
exports.max = max;
const hasDiffParents = (node) => node.parents.map(prop('type')).filter(unique).length > 1;
exports.hasDiffParents = hasDiffParents;
//# sourceMappingURL=index.js.map